<?php
/**
 *  Class to generate Meta Boxes & Custom Fields for IOA Framework
 *  @class : IOAMetaBox
 *  @version : 3.5
 *  @author : Artillegence
 *  @package : IOA
 *  @category : class
 */


if(!class_exists('IOAMetaBox')) {


  class IOAMetaBox {
  	
  	/** Settings for Meta Field **/
  	 private $params;

  	 /**
  	  *  Take settings and generate a meta box
  	  * @param $params array 
  	  */
	  function __construct($params)
	  {
		
		$this->params = $params;
		
		add_action( 'add_meta_boxes', array( &$this, 'add_custom_meta_box' ) );
		add_action( 'save_post', array( &$this, 'custom_save_data' ));
	  }
  
  	/**
  	 * Function to add meta box UI 
  	 * */
  	
	function add_custom_meta_box()
	{

		/**
		 *  Get Post Types or Post Type
		 * */

		$post_types = explode(',',$this->params['post_type']);

		foreach($post_types as $post_type)  
			add_meta_box
			( 
				$this->params['id'],
				$this->params['title'] , 
				array(&$this,"custom_html_wrap")  , 
				$post_type, 
				$this->params['context'], 
				$this->params['priority'] 
			);

	}
	
	/**
	 * Function to Generate HTML Interface
	 * */

	function custom_html_wrap()
	{
		global $post;

		$tag = $this->params['id'];

		/**
		 *  Nonce Check
		 * 
		 * */

		echo '<input type="hidden" name="'.sanitize_text_field($tag).'" id="'.esc_attr($tag).'" value="'.wp_create_nonce($tag).'" />';

		if(isset($this->params['description'])) echo '<div class="ioa-information-p">'.$this->params['description'].'</div>';

		$fields = $this->params['inputs'];

		foreach($fields as $field)
		{
			
			if( get_post_meta($post->ID,$field['name'],true) !="" )
				$field['value']	= get_post_meta($post->ID,$field['name'],true);
			
			echo getIOAInput($field);
		}


	}	 
	
	/**
	 * Hook to Save Meta Box's Input Data
	 */

	function custom_save_data() 
	{
		global $post;
		if(!isset($post->ID)) return;

		$fields = $this->params['inputs'];
		foreach($fields as $field)
		{
			if(isset($_POST[$field['name']]))
				update_post_meta($post->ID, $field['name'] , $_POST[$field['name']]);
		}

	}
	 
	 
           }  // ## END OF CLASS
  
 }  //## END OF CLASS EXISTS
  
