<?php
/**
 *  Main Input Interface Generators for IOA Framework
 *  @version : 3.5
 *  @author : Artillegence
 *  @package : IOA
 *  @category : function
 */

if(!function_exists('getIOAInput'))
{
	/**
	 * Function to Generate Input with label and description
	 * @param $params array 
	 */
	function getIOAInput($params = array() )
	{
		$color=  $d_str =  $d_c=   $class=  $after_input =   $icon_button = ''; $data = array(); 

		if(!isset($params['type'])) 
			$params['type'] = 'text';
		
		if(!isset($params['label'])) 
			$params['label'] = '';
		
		if(!isset($params['name'])) 
			$params['name'] = '';

		if(  $params['type']=="module") 
			return getIOAModule($params);

		if(  $params['type']=="divider") 
			return "<div class='ioa-divider'><div class='divider-text'>".$params['label']."</div></div>";

		if(isset($params['after_input'])) $after_input = $params['after_input'];
		if(isset($params['data'])) $data = $params['data'];	
		if(isset($params['class'])) $class = $params['class'];		
		if(isset($params['color'])) $color = $params['color'];		
		if(isset($params['buttons'])) $icon_button =$params['buttons'];	

		if(is_array($data))
		foreach($data as $k => $v)
		{
			if(!is_array($v)) :
				$d_str .= ' data-'.$k." ='".$v."' ";
				$d_c .= "_".$v;
			endif;
		}


		if($params['type']=="hidden") return "<div class='ioa_input hidden-field clearfix $d_c $class' $d_str >".getIOAHiddenInput($params).$after_input."</div>";
		if($params['type']=="info") return '<div class="ioa-information-p">'.$params['default'].'</div>';
		
		$editor =''; $desc = '';
		if(isset($params['is_editor']) && $params['is_editor'] )  $editor =' editor ';
		
		if($params['type'] == 'upload' || $params['type'] == 'video') $class .= ' has-input-button ioa-image-upload-text ';	

		if($params['type']=='toggle')
		{
			$class .= ' ioa-toggle-wrap ';	
		}

		$beforeInput ='';

		if(isset($params['description'])) $desc = $params['description'];			
		if(isset($params['beforeInput'])) $beforeInput = $params['beforeInput'];			
		$str = " 
				<div class='ioa_input clearfix $d_c $class' $d_str data-label='".strtolower($params['label'])."' >
					<label style='color:{$color}'> ".$params['label']." $icon_button ".getIOATooltip($desc)." </label>
					 $beforeInput
					<div class='ioa_input_holder clearfix ".$editor." '>
					
					";

		

		switch($params['type'])
		{
			case 'text' : $str .= "<a class='input-val-delete cancel-1icon- ioa-front-icon' href=''></a> ".getIOATextInput($params); break;
			case 'textarea' : $str .= "<a class='input-val-delete cancel-1icon- ioa-front-icon' href=''></a> ".getIOATextAreaInput($params); break;
			case 'select' : $str .= getIOASelectInput($params); break;
			case 'checkbox' : $str .= getIOACheckboxInput($params); break;
			case 'radio' : $str .= getIOARadioInput($params); break; 
			case 'toggle' : $str .= getIOAToggleInput($params); break; 
			case 'colorpicker' : $str .= "<a class='picker-delete cancel-1icon- ioa-front-icon' href=''></a> ".getIOAColorpickerInput($params); break;
			case 'slider' : $str .=getIOASliderInput($params); break;
			case 'upload' : $str .= "".getIOAUploadInput($params); break;
			case 'icon' : $str .= "".getIOAIconInput($params); break;
			case 'zipupload' : $str .= getIOAZipUploadInput($params); break;
			case 'video' : $str .= "<a class='input-val-delete cancel-1icon- ioa-front-icon' href=''></a> ".getIOAVideoInput($params); break;
			case 'hidden' : $str .= getIOAHiddenInput($params); break; 
			case 'module' : $str .= getIOAModule($params); break; 
			

		}			

		$markup = '';
		if(isset($params['addMarkup'])) $markup = $params['addMarkup'];

		$str .= "	".$markup."
					</div> $after_input</div> 

				";

		return $str;		
	}
}

/**
 * Function to create Modules
 */

if(!function_exists('getIOAModule'))
{
	function getIOAModule($params)
	{
		
		$value = '';
		
		$v = '';


		if(isset($params['value']))	$v = $params['value'];

		$processed_inp = '';
		$data_field = getIOAInput(array( "label" => "" , "name" => $params['name']."" , 'class' => ' mod_data' , "default" => "" , "type" => "hidden", "description" => "", "length" => 'medium', "value" => $v ) 
	);			
		$values = array(); $setval = '';
		if(isset($params['value'])) $values = explode('[ioa_mod]',$params['value']);

		foreach ($values as $key => $value) {
			
			if($value!="")
			{
				$inpval = array();
				$mods = explode('[inp]', $value);	
				
				foreach($mods as $m)
				{

					if($m!="")
					{
						$te = (explode('[ioas]',$m)); 
						if(isset($te[1]))
						$inpval[$te[0]] = $te[1]; 
					}

					
				}

				$context = '';
				if( isset($params['head_title']) )
					$context = $inpval[$params['head_title']];

				$setval .= '<div class="ioa_module ">
								<div class="module_head">
								 '.$params['unit'].' : <strong>'.$context.'</strong>  <a class="pencil-3icon- ioa-front-icon edit-mod" href=""></a> <a href="" class="docsicon- ioa-front-icon clone-mod"></a> <a class="delete-mod cancel-1icon- ioa-front-icon" href=""></a>
								</div>
								<div class="module_body">';

							foreach($params['inputs'] as $input) 
							{
								$input['value'] = '';

								if(isset($inpval[$input['name']]))
									$input['value'] = $inpval[$input['name']];

								

								$temp = $input;

								if(isset($inpval[$input['name'].'_opacity']))
									$temp['opval'] = $inpval[$input['name'].'_opacity'];
								
								if(isset($temp['class'])) 
									$temp['class'] .= ' ioa_mod_input ';
								else
									$temp['class'] = ' ioa_mod_input ';
								
								$setval .= getIOAInput($temp);	
							}
									
				$setval .= '</div>  

							</div>	';

				//prettyPrint($inpval);
				
			}

		}

		foreach($params['inputs'] as $input) 
			{
				$temp = $input;
				if(isset($temp['class'])) 
					$temp['class'] .= ' ioa_mod_input ';
				else
					$temp['class'] = ' ioa_mod_input ';
								
				$processed_inp .= getIOAInput($temp);	
			}

		$class = '';
		$control = '';	
		$im_mod = '';
		$im_target = ''; 

		if(isset($params['class']))	 $class = $params['class'];
		if(isset($params['control']))	 $control = $params['control'];
		if(!isset($params['description'])) $params['description'] = '';
		if(isset($params['image_mod']))
		{
			 $im_mod = ' image-mod-trigger ';
		}
		if(isset($params['image_target'])) $im_target = 'data-target="'.$params['image_target'].'"';

		$markup = '<div class="ioa_module_container '.$class.' clearfix"> 
		<div class="ioa_module_container_head clearfix"> <span>'.$params['label'].'</span> <span class="mod_desc">'.$params['description'].'</span> <div class="ioa_module_button_panel clearfix"><a data-restore="'.__('Update Changes','ioa').'" data-save="'.__('Saved','ioa').'" class="button-save save-ioa-module" href="">'.__('Update Changes','ioa').'</a>  </div> </div>	
						<div class="ioa_module_container_body"><a class="button-default add-ioa-module '.$im_mod.'" '.$im_target.' href=""><i class="ioa-front-icon plus-3icon-"></i></a>
							<div class="module_list">
								'.$setval.'
							</div>

							<div class="ioa_module hide">
								<div class="module_head">
								 '.$params['unit'].'  <a class="edit-mod pencil-3icon- ioa-front-icon" href=""></a><a href="" class="docsicon- ioa-front-icon clone-mod"></a> <a class="delete-mod delete-mod cancel-1icon- ioa-front-icon" href=""></a>
								</div>
								<div class="module_body">
									'.$processed_inp.'
								</div>  

							</div>	

							'.$data_field.'	
						</div>
				   </div>';
			
		return $markup;
	}
}



/**
 * Function to create Text Fields
 */
if(!function_exists('getIOATextInput'))
{
	function getIOATextInput($params)
	{
		$value = '';
		$def = '';
		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else if(isset($params['default']))
			$value = $params['default'];

		if(isset($params['default'])) $def = $params['default'];

		$value = stripslashes($value);

		$str = " <input type='text' data-default='".$def."' value=\"".$value."\" name='".$params['name']."' id='".$params['name']."' class='".$params['name']."'/> ";


		return $str;
	}
}

/**
 * Function to create Hidden Fields
 */
if(!function_exists('getIOAHiddenInput'))
{
	function getIOAHiddenInput($params)
	{
		$value = '';
		
		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
		{
			$value = $params['default'];

			if($params['name'] == 'uniq')
				$value =  uniqid();

		}

		

		$str = " <input type='hidden'  data-default='".$params['default']."' value='".$value."' name='".$params['name']."' id='".$params['name']."' class='".$params['name']."'/> ";

		return $str;
	}	
}

/**
 * Function to create Upload Fields
 */
if(!function_exists('getIOAUploadInput'))
{
	function getIOAUploadInput($params)
	{
		$value = '';
		$label = __('Add','ioa');
		$title = __('Add Image','ioa');
		
		if( isset($params['button']) && trim($params['button']) != ""  )  $label = $params['button'];
		if( isset($params['title']) && trim($params['title']) != ""  )  $title = $params['title'];	

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		if(!isset($params['multi']))
			$params['multi']  = false;

		$str = " <div class='image_upload_wrap clearfix'>
					<div class='clearfix'><input type='hidden' class=' ".$params['name']."'  data-default='".$params['default']."' value='".$value."' name='".$params['name']."' id='".$params['name']."' /></div>"; 

		$style ='  ';	

		if( LEAP_isImage($value) )		
			$value = $value;
		else
		{
			$value = LEAP_getImage($value,'medium');
			$value =$value['src'];	
		}


		if(trim($value)!="") $style =' has-image ';	
		
			$str .= "<div class='input-image-preview $style' >
			<a href='' data-title='$title' data-label='$label'  data-multi='".$params['multi']."' class='image_upload '><i class='ioa-front-icon plus-3icon- '></i></a> 
					<img src='".$value."' alt='input image preview' />
					<div class='v-al'><span class='i-label'>".$title."</span></div>
					<a href='' class='ioa-image-upload-overlay himage-remove'><i class=' ioa-ti ti-close  delete image'></i></a>
				 </div>";
						

		$str .= "</div>";

		return $str;
	}
}



/**
 * Function to create Upload Fields
 */
if(!function_exists('getIOAIconInput'))
{
	function getIOAIconInput($params)
	{
		$value = '';
		$label = __('Add','ioa');
		$title = __('Set Icon','ioa');
		

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		if(!isset($params['multi']))
			$params['multi']  = false;

		$str = " <div class='icon_upload_wrap clearfix'>
					<div class='clearfix'><input type='hidden' class=' ".$params['name']."'  data-default='".$params['default']."' value='".$value."' name='".$params['name']."' id='".$params['name']."' /></div>"; 

		$style ='  ';			

		if(trim($value)!="") $style =' has-icon ';	
		
			$str .= "<div class='input-icon-preview $style' >
			<a href='' data-title='$title' data-label='$label' data-multi='".$params['multi']."' class='icon-maker icon_upload '><i class='ioa-front-icon plus-3icon- '></i></a> 
				<i class='".$value."' ></i>
				<div class='v-al'><span class='i-label'>".$title."</span></div>
				<a href='' class='ioa-icon-upload-overlay hicon-remove'><i class=' ioa-ti ti-close  delete '></i></a>
			 </div>";
						

		$str .= "</div>";

		return $str;
	}
}

/**
 * Function to create Zip Upload Fields
 */
if(!function_exists('getIOAZipUploadInput'))
{
	function getIOAZipUploadInput($params)
	{
		$value = '';
		$label = __('Add','ioa');
		$title = __('Add Zip File','ioa');
		
		if( isset($params['button']) && trim($params['button']) != ""  )  $label = $params['button'];
		if( isset($params['title']) && trim($params['title']) != ""  )  $title = $params['title'];	

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		$str = " <div class='image_upload_wrap clearfix'>
					<div class='clearfix'><a href='' data-title='$title' data-label='$label' class='zip_upload button-default'> ".__('Upload','ioa')." </a> <input type='text' class='".$params['name']."'  data-default='".$params['default']."' value='".$value."' name='".$params['name']."' id='".$params['name']."' /></div>"; 
		$str .= "</div>";

		return $str;
	}

}

/**
 * Function to create Video Fields
 */
if(!function_exists('getIOAVideoInput'))
{
	function getIOAVideoInput($params)
	{
		$value = '';
		$label = __('Add','ioa');
		$title = __('Add Video','ioa');
		
		if( isset($params['button']) && trim($params['button']) != ""  )  $label = $params['button'];
		if( isset($params['title']) && trim($params['title']) != ""  )  $title = $params['title'];	

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		$str = " <div class='image_upload_wrap clearfix'>
					<div class='clearfix'><a href='' data-title='$title' data-label='$label' class='video_upload button-default'> ".__('Upload Video','ioa')." </a> <input type='text' class='".$params['name']."'  data-default='".$params['default']."' value='".$value."' name='".$params['name']."' id='".$params['name']."' /></div>"; 
		$str .= "</div>";

		return $str;
	}
}


/**
 * Function to create Slider Fields
 * @param  max_val maximum value for the slider
 * @param  suffix  the type of slider
 * @param  steps amount of increment on dragging
 */
if(!function_exists('getIOASliderInput'))
{
	function getIOASliderInput($params)
	{
		$value = '';
		$max_val = 500;
		$suffix = '';
		$steps = 1;
		if(isset($params['max'])) $max_val = $params['max'];
		if(isset($params['steps'])) $steps = $params['steps'];
		if(isset($params['suffix'])) $suffix = $params['suffix'];
		if( isset($params['value']) ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		$def = '0';
		if(isset($params['default'])) $def = $params['default'];

		// suffix disable for now

		$str = " <div class='ioa_slider'></div><input  data-default='".$def."' data-max='{$max_val}' data-steps='{$steps}' type='text' class='slider-input' value='".$value."' name='".$params['name']."' id='".$params['name']."' />". "<a class='input-val-delete slider-delete cancel-1icon- ioa-front-icon' href=''></a> ";

		return $str;
	}

}

/**
 * Function to create Colorpicker Fields
 */
if(!function_exists('getIOAColorpickerInput'))
{
	function getIOAColorpickerInput($params)
	{
		$value = '';
		$opacity = "false";
		$def = '';

		

		$opval = 1;

		if(isset($params['opacity']) && $params['opacity']  )
			$opacity = "true";	
		
		if(isset($params['opval'])   )
			$opval = $params['opval'];

		if( isset($params['value']) && $params['value']  != ""  ) 
			{
				
				$value = trim($params['value']);
				if(isset($params['default'])) $def = trim($params['default']);
				
			}
		else if(isset($params['default']))
			{
				$def =	$value = trim($params['default']);
			}
		

		$str = "<div class='colorpicker-wrap'>
				<div class='minicolors  minicolors-theme-default minicolors-position-bottom minicolors-position-left ' >	
					
					<input type='text' data-op='".$opacity."'  data-opacity='".$opval."'  data-default='".$def."'  value='".$value."' name='".$params['name']."' id='".$params['name']."' class='ioa-minicolors minicolors-input ".$params['name']. "' />".'
					<span class="minicolors-swatch minicolors-sprite"><span class="minicolors-swatch-color"></span></span>	
						
						<div class="minicolors-panel minicolors-slider-hue">
							<div class="minicolors-slider minicolors-sprite">
								<div class="minicolors-picker"></div>
							</div>
							<div class="minicolors-opacity-slider minicolors-sprite">
								<div class="minicolors-picker"></div>
							</div>
							<div class="minicolors-grid minicolors-sprite">
								<div class="minicolors-grid-inner"></div>
								<div class="minicolors-picker">
									<div></div>
								</div>	
							</div>
						</div>

				</div>
						';
				
		$str .="		 </div> ";

		return $str;
	}
}

/**
 * Function to create Text Area
 */
if(!function_exists('getIOATextAreaInput'))
{
	function getIOATextAreaInput($params)
	{
		$value = '';

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		$value = stripslashes($value);

		if(isset($params['is_editor']) && $params['is_editor'] ) 
		{
			$settings =   array(
				    'wpautop' => false, // use wpautop?
				    'media_buttons' => true, // show insert/upload button(s)
				   'textarea_name' =>  $params['name'], // set the textarea name to something different, square brackets [] can be used here
				    'textarea_rows' => get_option('default_post_edit_rows', 10), // rows="..."
				    'textarea_columns' => 4,
				    'tinymce' => array(
				    	'convert_newlines_to_brs' => true,
				        'theme_advanced_buttons1' => 'bold,italic,underline,blockquote,|,bullist ,numlist  , link,unlink, ioabutton',
				        'theme_advanced_buttons2' => '',
				        'theme_advanced_buttons3' => '',
				        'theme_advanced_buttons4' => '',
				          'content_css' => get_stylesheet_directory_uri() . '/sprites/stylesheets/custom-editor-style.css' 
				    ),
				    'tabindex' => '',
				    'editor_class' => $params['name']." rad-editor", // add extra class(es) to the editor textarea
				    'teeny' => false, // output the minimal editor config used in Press This
				    'dfw' => false, // replace the default fullscreen with DFW (supported on the front-end in WordPress 3.4)
				    '_content_editor_dfw' => false,
				    'quicktags' => true // load Quicktags, can be used to pass settings directly to Quicktags using an array()
				);	
			
			ob_start();
			
			wp_editor( $value, $params['name'], $settings);
			$str = ob_get_contents();
			ob_end_clean();
		}
		else
		{
			$name = "name='".$params['name']."'";
			if(isset($params['noname'])) $name = '';
			
			$str = " <textarea  data-default='".$params['default']."' $name id='".$params['name']."'  class='expanding ".$params['name']."'>".$value."</textarea>";
		}
		return $str;
	}
}

/**
 * Function to create Select Dropdown
 */
if(!function_exists('getIOASelectInput'))
{
	function getIOASelectInput($params)
	{
		$value = '';
		$def = '';

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else if(isset($params['default']))
			{
				$value = $params['default'];
			}

		if(  isset($params['default'])) $def = $params['default'];

		$opts ='';

		$useKey = true;
		if( ! isAssoc($params['options']) ) $useKey = false;

		if( isset($params['optgroup']) ) :
			foreach($params['options'] as $key => $optgroup)
			{
				$opts .= "<optgroup label='$key'>";

				foreach ($optgroup as $k => $option) {
					
					$v = $option;
					if($useKey) $v = $k;

					if($value == $v)
					$opts .= "<option selected='selected' value='".$v."'> ".$option."</option>";
					else	
					$opts .= "<option value='".$v."'> ".$option."</option>";

				}

				$opts .= "</optgroup>";

			}

		else : 

		foreach($params['options'] as $key => $option)
		{
			$v = $option;
			if($useKey) $v = $key;

			if($value == $v)
			$opts .= "<option selected='selected' value='".$v."'> ".$option."</option>";
			else	
			$opts .= "<option value='".$v."'> ".$option."</option>";
		}
		endif;

		$str = " <div class='ioa_select_wrap'><i class='ioa-front-icon down-open-2icon- '></i><select   data-default='".$def."' name='".$params['name']."' id='".$params['name']."' class='".$params['name']."'>".$opts."</select></div>";

		return $str;
	}
}

/**
 * Function to create Checkboxes
 */
if(!function_exists('getIOACheckboxInput'))
{
	function getIOACheckboxInput($params)
	{
		$value = array();
		
		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = explode(",",$params['value']);
		else
			{
				if(!is_array($params['default']))
					$value = explode(",",$params['default']);
				else 
					$value = $params['default'];
			}

		$opts ='';
		$i=0;	

		$useKey = true;
		if( ! isAssoc($params['options']) ) $useKey = false;

		foreach($params['options'] as $key => $option)
		{
			$v = $option;
			if($useKey) $v = $key;
			
			if( in_array($v,$value))
				$opts .= "<div class='group-check-wrap clearfix checkbox'><label for='".$params['name'].$i."'><input type='checkbox' name='".$params['name']."' id='".$params['name'].$i."' checked='checked' value='".$v."' /> <span class='check-label'> ".$option."</span></label></div>";
			else	
				$opts .= "<div class='group-check-wrap clearfix checkbox'><label for='".$params['name'].$i."'><input type='checkbox' name='".$params['name']."' id='".$params['name'].$i."' value='".$v."' /> <span class='check-label'> ".$option."</span></label></div>";
			$i++;
		}

		$str = " <div class='ioa_checkbox_wrap'> ".$opts." </div>";

		return $str;
	}
}


/**
 * Function to create Radio
 */
if(!function_exists('getIOARadioInput'))
{
	function getIOARadioInput($params)
	{
		$value = array();
		
		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = explode(",",$params['value']);
		else
			$value = explode(",",$params['default']);

		$opts ='';
		$i=0;	

		$useKey = true;
		if( ! isAssoc($params['options']) ) $useKey = false;

		foreach($params['options'] as $key => $option)
		{
			$v = $option;
			if($useKey) $v = $key;

			if( in_array($v,$value))
				$opts .= "<div class='group-check-wrap radio' ><label for='".$params['name'].$i."'><input type='radio' name='".$params['name']."' id='".$params['name'].$i."' checked='checked' value='".$v."' /> <span class='check-label'>".$option."</span></label></div>";
			else	
				$opts .= "<div class='group-check-wrap radio' ><label for='".$params['name'].$i."'><input type='radio' name='".$params['name']."' id='".$params['name'].$i."' value='".$v."' /> <span class='check-label'>".$option."</span></label></div>";
			$i++;
		}

		$str = " <div class='ioa_radio_wrap'> ".$opts." </div>";

		return $str;
	}
}

/**
 * Function to create Toggles
 */
if(!function_exists('getIOAToggleInput'))
{
	function getIOAToggleInput($params)
	{
		$value = 'true';

		if( isset($params['value']) && trim($params['value']) != ""  ) 
			$value = $params['value'];
		else
			$value = $params['default'];

		$false_opts = $true_opts ='';


		if(  $value == "true")
		{
			$true_opts = " checked='checked' ";
		}	
		else
			$false_opts = " checked='checked' ";

		$str = " <div class='ioatoggle_wrap togglebutton clearfix'> <span class='indicator'>".__('No')."</span><label for='".$params['name']."'><input  type='checkbox' name='".$params['name']."' id='".$params['name']."' $true_opts value='true' class='proxy-true' /> </label> <span class='indicator'>".__('Yes')."</span></div>

			<input  type='checkbox' class='proxy-false' name='".$params['name']."' id='".$params['name']."' $false_opts value='false' />";

		return $str;
	}
}


/**
 * Create Helper Tooltip
 */
if(!function_exists('getIOATooltip'))
{
	function getIOATooltip($description)
	{
		if($description=="") return '';

		$str = "<span class='ioa-tooltip-information'>".$description."</span>";
		return $str;		
	}

}

if(!function_exists('isAssoc'))
{
	function isAssoc($arr)
	{
			return array_keys($arr) !== range(0, count($arr) - 1);
	} 

}
