<?php 
/**
 *  Contains Core Functions
 * 
 * */


/**
 *  Convert value/name array to associative arrays
 *  @param $inptus array
 *  @param $key string
 * @param $noempty boolean
 *  @return array
 * */
if( ! function_exists('Leap_IOAAssocMap')) {

function Leap_IOAAssocMap($inputs,$key,$noempty=false)
{
	$arr = array();
	if(is_array($inputs))
	{
		foreach($inputs as $input)
	{
		if(isset( $input[$key]))
			{
				if( $noempty)
					{
						if(trim( $input[$key])!="")
						$arr[$input['name']] =   stripslashes($input[$key]);
					}
				else
				{
					if(isset($input['name'])) $arr[$input['name']] =    stripslashes($input[$key]);
				}	
			}
		else if(isset($input['name']))
			$arr[$input['name']] =   false;	
	}
	}
return $arr;	
}	

}



/**
 *  Check if String is a valid image
 * 
 * */

if(!function_exists('LEAP_isImage')) {

    function LEAP_isImage($image_string) {

        $info = pathinfo($image_string);
        if(!isset($info['extension']))
            return false;
          if(  in_array(strtolower($info['extension']),    array("jpg", "jpeg", "gif", "png", "bmp")) )
        {
            return true;
        }
         else
            return false;

    }   

}

/**
 *  Get Appropiate Image 
 * 
 * */

if(!function_exists('LEAP_getImage')) {

    function LEAP_getImage($image,$size = 'full') {
         

         $alt = $title = $description = $caption  = $src =  $width =  $height = '' ;
        

         if(LEAP_isImage($image))
        {
            /*
            $data = @getimagesize ($image);
            $width = $data[0];
            $height = $data[1];
            */
        $src = $image;
        }       
        else
        {

            $attachment = get_post($image,"ARRAY_A");
            
            if(!$attachment)    
            {
                if($image!='')
                 $src ='';
            }   
            else        
        {
            
            $src = wp_get_attachment_image_src($image,$size);
            $width = $src[1];
            $height = $src[2];
            $src  = $src[0];

            if(function_exists('IOA_afterImage')) :
            $src = IOA_afterImage(
                    array(
                        "src" => $src,  "id" => $image

                            )
                );
            $src = $src['src'];
           endif;
            $alt = get_post_meta($image, '_wp_attachment_image_alt', true);
            $title = $attachment['post_title'];
            $caption = $attachment['post_excerpt'];
            $description = $attachment['post_content'];
        }
        
        // if(trim($src) == '') $src = URL.'/sprites/i/dummy.png';
        }      

     

        return array(
                    "src" => $src,
                    "alt" => $alt,
                    "title" => $title,
                    "description" => $description ,
                    "caption" => $caption,
                    "width" => $width, 
            "height" => $height 
                );

    }   
}

function LEAP_canned($atts,$content,$code)
{
        $str = '';

        $post = get_post($atts[0]);
        if($post )
        {
                    $str = $post->post_content;
        }

        return $str;
}
add_shortcode('leapcanned','LEAP_canned');


/**
     * Get modular data for Module Inputs
     *  @param $mod_str string
     * 
     * */
 
if( ! function_exists('LEAP_getModuleData') )
{

            function LEAP_getModuleData($mod_str = '')
            {
                if($mod_str == '') return array();
                $resultset = array();
                $tab_data = explode('[ioa_mod]',$mod_str);
                foreach ($tab_data as $key => $value) 
                {
                            
                    if($value!="")
                    {
                        $inpval = array('id' => uniqid('ioa_widget_'));
                        $mods = explode('[inp]', $value);   
                        
                        foreach($mods as $m)
                        {
                            
                            if($m!="")
                            {
                                $te = (explode('[ioas]',$m));  
                                if( count($te) == 1 ) $te = (explode(';',$m));  
                                
                                if(isset($te[1]))
                                $inpval[$te[0]] =   $te[1]  ; 
                                
                            }

                            
                        }

                        $resultset[] = $inpval;
                    }   
                }

                return $resultset;  

            }

}    


//Get an array with geoip-infodata
function LEAP_get_location($ip = false)
{
     if(!$ip)
        $ip = $_SERVER['REMOTE_ADDR'];

       //check, if the provided ip is valid
       if(!filter_var($ip, FILTER_VALIDATE_IP))
       {
               throw new InvalidArgumentException("IP is not valid");
       }

       //contact ip-server
       $response=@file_get_contents('http://www.netip.de/search?query='.$ip);
       if (empty($response))
       {
               throw new InvalidArgumentException("Error contacting Geo-IP-Server");
       }

       //Array containing all regex-patterns necessary to extract ip-geoinfo from page
       $patterns=array();
       $patterns["domain"] = '#Domain: (.*?)&nbsp;#i';
       $patterns["country"] = '#Country: (.*?)&nbsp;#i';
       $patterns["state"] = '#State/Region: (.*?)<br#i';
       $patterns["town"] = '#City: (.*?)<br#i';

       //Array where results will be stored
       $ipInfo=array();

       //check response from ipserver for above patterns
       foreach ($patterns as $key => $pattern)
       {
               //store the result in array
               $ipInfo[$key] = preg_match($pattern,$response,$value) && !empty($value[1]) ? $value[1] : 'not found';
       }

       return $ipInfo;
}




function leap_trigger_chat_shortcode($atts,$content)
{

 return "<a class='trigger-leap-chat' href='' title='".__('Trigger Chat','leap')."'>$content</a>";
}
add_shortcode("leap_trigger","leap_trigger_chat_shortcode");


function leap_listen_for_users() {

        // get the user activity the list
    $logged_in_users = get_transient('leap_online_status');

    // get current user ID
    $user = wp_get_current_user();

    // check if the current user needs to update his online status;
    // he does if he doesn't exist in the list
    $no_need_to_update = isset($logged_in_users[$user->ID])

        // and if his "last activity" was less than let's say ...15 minutes ago          
        && $logged_in_users[$user->ID] >  (time() - (15 * 60));

    // update the list if needed
    if(!$no_need_to_update){
      $logged_in_users[$user->ID] = time();
      set_transient('leap_online_status', $logged_in_users, $expire_in = (30*60)); // 30 mins 
    }


}
add_action('init','leap_listen_for_users');

function leap_remove_user() {
   
    $logged_in_users = get_transient('leap_online_status');
    $user = wp_get_current_user();

    if($logged_in_users && isset($logged_in_users[$user->ID]) ) {

        unset($logged_in_users[$user->ID]);
        set_transient('leap_online_status', $logged_in_users,  (30*60));
    }

}
add_action('wp_logout', 'leap_remove_user');


function leap_zipMimeSupport( $post_mime_types ) 
        {

            $post_mime_types['application/zip'] = array( esc_html__( 'Zips' ,'leap'), esc_html__( 'Manage Zips','leap' ), _n_noop( 'Font <span class="count">(%s)</span>','' .esc_html__('Zips','leap'). '<span class="count">(%s)</span>' ) );

           $post_mime_types['application/pdf'] = array( __( 'PDFs','leap' ), __( 'Manage PDFs','leap' ), _n_noop( 'PDF <span class="count">(%s)</span>', 'PDFs <span class="count">(%s)</span>','leap' ) );
   


            return $post_mime_types;

        }   

        // Add Filter Hook
        add_filter( 'post_mime_types', 'leap_zipMimeSupport' );  


