<?php
/**
 * Listens for all Ajax Queries / Engines
 */


add_action('wp_ajax_nopriv_leap_chat_Listener', 'leap_chat_Listener');
add_action('wp_ajax_leap_chat_Listener', 'leap_chat_Listener');


/**
 * Query Maker Engine
 */


function leap_chat_Listener() {



$type = $_REQUEST["type"]; 
 
 $structure = array(

        "operator_id" => "",
        "user_id" => "",
        
        "operator_msg" =>  array(),
        "user_msg" =>  array(),

        "operator_flag" => "",
        "user_flag" => "",

        "user_time" => ""

        );

if($type=="visitor_tree") :

    if( get_option('LEAP_offline') && get_option('LEAP_offline') == 'true' ) :
    
        echo 'offline';
    else :

        $visitors = get_transient('LEAP_Visitor_tree' );
        $user_id = $_POST['user_id'];
        $user_name = $_POST['user_name'];
        $flag = $_POST['flag'];
        if(!$visitors)
            $visitors =  array();

        $visitors[$user_id] = array("user_name" => $user_name , "flag" => $flag , "operator_id" => '' , "user_id" => $user_id );
        echo set_transient('LEAP_Visitor_tree',$visitors);
        

    endif;


elseif($type=="add_new_visitor") :

    if( get_option('LEAP_op_notify') && get_option('LEAP_op_notify')  ==  'true' ) {

            $access_users = get_option('LEAP_chat_users');
            if($access_users &&  $access_users!='' ){

                $access_users = explode(';',$access_users);
                foreach ($access_users as $key => $user) {
                    
                    $u = get_user_by('id',$user);
                   if($u)
                    echo wp_mail(  $u->user_email , 'New Visitor ', 'You have a new visitor' );
                }

            } 
    
        }
        
    if( get_option('LEAP_offline') && get_option('LEAP_offline') == 'true' ) :
    
        echo 'offline';
    else :

        $visitors = get_transient('LEAP_Visitor_tree' );
        $user_id = $_POST['user_id'];
        $user_name = $_POST['user_name'];
        $flag = $_POST['flag'];
        if(!$visitors)
            $visitors =  array();

        $visitors[$user_id] = array("user_name" => $user_name , "flag" => $flag , "operator_id" => '' , "user_id" => $user_id );

        
        echo set_transient('LEAP_Visitor_tree',$visitors);

        

        

    endif;


elseif($type=='offline-message') :

    $fields = $_POST['fields'];
    $email = get_option('LEAP_offline_email');

    if(! $email)
        $email =  get_option('admin_email');


    $subject =  __('Offline Message','leap');

    $message = '';

    foreach ($fields as $key => $field) {
            $message .=  " $key : $field \n\n ";
        }   

    echo wp_mail($email, $subject , $message);

elseif($type=='kill_session') :

    $visitors = get_transient('LEAP_Visitor_tree' );
    $user_id = $_POST['user_id'];
    $chat_log = '';
    $session =  get_transient('LEAP-session-'.$user_id) ;

    if($visitors[$user_id])
        unset($visitors[$user_id]);

    if($session) : 
        
        if(isset($_POST['chat_log']))
            $chat_log = $_POST['chat_log'];

        $init_data =  $visitors[$user_id];

        $chat = array(
                  'post_title'     =>  "Chat between Operator ".$session['operator_id'].' - '.$session['user_name']. ' on '.date('l jS \of F Y h:i:s A') ,
                  'post_type'      =>  'leapchatarchive'  ,
                  'post_status' => 'publish'
                );  

        $id = wp_insert_post( $chat );
        
        update_post_meta($id,'session' , $session );
        update_post_meta($id,'init_data' , $init_data );
        update_post_meta($id,'human_log' , $chat_log );
        
        unset($visitors[$user_id]);
        
        set_transient('LEAP_Visitor_tree' ,$visitors);
        delete_transient('LEAP-session-'.$user_id);

    endif;

elseif($type=='purge-cache') :

    $logs = get_option("LEAP_all_session");
    if($logs) :
        foreach ($logs as $session) {
            if(!is_array($session) && $session  == 'killed')
                delete_transient($session );
        }
    endif;  
    
elseif($type=='purge-analytics') :  

    echo  delete_option('LEAP_ANALYTICS');

elseif($type=='purge-archives') :  

    $args = array(
    'numberposts' => -1,
    'post_type' =>'leapchatarchive'
    );
    $posts = get_posts( $args );
   
    if (is_array($posts)) :
       foreach ($posts as $post) {
           wp_delete_post( $post->ID, true);
       }
    endif;
   

elseif($type == 'user_status') :

    $visitors = get_transient('LEAP_Visitor_tree' );
    $user_id = $_POST['user_id'];


    if(isset($visitors[$user_id])) :
    
        if($visitors[$user_id]['operator_id']!='')
            echo $visitors[$user_id]['flag'];
        else
            echo 'none';
    endif;

elseif($type == 'set_user_status') :

    $visitors = get_transient('LEAP_Visitor_tree' );
    $user_id = $_POST['user_id'];
    $operator_id = $_POST['operator_id'];
    $status = $_POST['status'];

    if(isset($visitors[$user_id])) :
         $visitors[$user_id]['flag'] = $status;
         $visitors[$user_id]['operator_id'] = $operator_id;
         $visitors[$user_id]['operator_uid'] = $_POST['operator_uid'];
    endif;

    
    if($status!=="die" && $status!=="reconnected")
        {
            $user = $structure;
            $user['operator_id'] =  $operator_id;
            $user['user_id'] =  $user_id;
            set_transient('LEAP-session-'.$user['user_id'] , $structure);
        }


    set_transient('LEAP_Visitor_tree',$visitors);

elseif($type =='get-user-metadata') :

    $user_id = $_POST['user_id'];
    $session =  get_transient('LEAP-session-'.$user_id);

    if(isset($session['user_data'])) :
        echo json_encode( $session['user_data'] );
    endif;

elseif($type=='setup_chat') :

    $user = $structure;
    $user['user_id'] = $_POST['user_id'];

    $location = 'N/A';

    if(!isset($user['user_id']))
        return;

    $user_data = $_POST['user_data'];
    $technical = $_POST['technical'];
    
    if(isset($_POST['location']))
    $location = $_POST['location'];

    $visitors = get_transient('LEAP_Visitor_tree' );

    $saved_session = get_transient('LEAP-session-'.$user['user_id']  );


    if(isset($visitors[$user['user_id']])) :

        
        if($saved_session && $saved_session['operator_id']!="") :
            $user = $saved_session;
        else :      
            
                $v = $visitors[$user['user_id']];
            
                $user['operator_id'] = $v['operator_id'];
                $user['user_name'] = $v['user_name'];

                
                $user['operator_uid'] = $v['operator_uid'];

                if(isset($_POST['operator_uid']) && $_POST['operator_uid']!='' )
                    $user['operator_uid'] = $_POST['operator_uid'];
                
                $user['operator_avatar']  = esc_attr( get_the_author_meta( 'custom_profile_image', $user['operator_uid'] ) );
                $user['operator_avatar']  =  LEAP_getImage($user['operator_avatar']);
                $user['operator_avatar']  =  $user['operator_avatar']['src'];

                $user['operator_desig']  = esc_attr( get_the_author_meta( 'leap_designation', $user['operator_uid'] ) );

                $user['user_time'] =  time();
                $user['user_data'] =  array("data" => $user_data, "location" => $location , "technical" => $technical );

                $ga = get_option('LEAP_ANALYTICS');
                if(!$ga)    
                    $ga = array();

                $ga[uniqid()] =   array("data" => $user_data, "location" => $location , "technical" => $technical  , "name" => $v['user_name'] , 'user_id' => $user['user_id']  , "operator" => $user['operator_id'] , "time" => time() );
                
                update_option('LEAP_ANALYTICS',$ga);    

                

        endif;      
        

        $user['flag'] =  'active';
        $user['user_id'] =  $_POST['user_id'];
        
        $visitors[$user['user_id']]['flag'] = 'connected'; 
            
        set_transient('LEAP_Visitor_tree',$visitors);
        set_transient('LEAP-session-'.$user['user_id'] , $user);

    endif;

    echo json_encode($user);

    $logs = get_option("LEAP_all_session");
    if(!$logs)
        $logs = array();

    $logs[] =  'LEAP-session-'.$user['user_id'];
    update_option("LEAP_all_session",$logs);

elseif($type == 'set-operator-message') :

    $user_id = $_POST['user_id'];
    $message = $_POST['message'];
    $session =  get_transient('LEAP-session-'.$user_id);
    $session['operator_flag'] = '';
    if(is_array($message))
    {
        foreach ($message as $key => $m) {
            $session['operator_msg'][microtime()] =  stripslashes(do_shortcode(make_clickable($m)));
        }
    }
    else
        $session['operator_msg'][microtime()] =  stripslashes( do_shortcode(make_clickable($message)) );

    set_transient('LEAP-session-'.$user_id , $session);

elseif($type == 'set-operator-typing') :

    $user_id = $_POST['user_id'];
    $message = $_POST['message'];
    $session =  get_transient('LEAP-session-'.$user_id);

    $session['operator_flag'] =  stripslashes( $message );

    set_transient('LEAP-session-'.$user_id , $session);

elseif($type == 'set-user-message') :

    $user_id = $_POST['user_id'];
    $message = $_POST['message'];
    $session =  get_transient('LEAP-session-'.$user_id);

    if(is_array($message))
    {
        foreach ($message as $key => $m) {
            $session['user_msg'][microtime()] =  stripslashes(make_clickable($m));
        }
    }
    else
        $session['user_msg'][microtime()] =  stripslashes( make_clickable($message) );

    set_transient('LEAP-session-'.$user_id , $session);



elseif($type == 'set-user-typing') :

    $user_id = $_POST['user_id'];
    $message = $_POST['message'];
    $session =  get_transient('LEAP-session-'.$user_id);

    $session['user_flag'] =  stripslashes( $message );

    set_transient('LEAP-session-'.$user_id , $session);


elseif($type=='get-user-messages') : 

    $user_id = $_POST['user_id'];
    $session =  get_transient('LEAP-session-'.$user_id);
    $last_time =  $_POST['timestamp'];

    $message =  '';


    
    if($last_time !== '' && is_array($session)) :

        $message = $session['operator_msg'];

        $key = array_search($last_time, array_keys($session['operator_msg']) );

        if ($key !== false) {
            $message = array_slice($session['operator_msg'], $key+1, null, true);
        }

    endif;
    
    if($last_time == '' && is_array($session) && isset($session['operator_msg']) )
        $message = $session['operator_msg'];

    if(empty($message))
            $message = '';
            
    if(!$session)
        $message = 'killed';
    
    $op = '';

    if(isset($session['operator_flag'])  )
        $op = $session['operator_flag'];


    $message = array( "message" => $message , "operator_flag" => $op );

    echo json_encode($message);

elseif($type=='get-operator-messages') : 

    $messages = array();
    if(isset($_POST['user_ids']))  :

    $user_ids = $_POST['user_ids'];

    foreach ($user_ids as $key => $user) {
        
        $session =  get_transient('LEAP-session-'.$user['user_id']);

        $last_time =  $user['timestamp'];
        
        if(isset($session['user_msg'])) 
            $message = $session['user_msg'];
        else
            $message = array();
        

        if($last_time !== '' && isset($session['user_msg']) ) :

            $key = array_search($last_time, array_keys($session['user_msg']) );

            if ($key !== false) {
                $message = array_slice($session['user_msg'], $key+1, null, true);
            }
        
        endif;

        if(!$session)
            $message = 'killed';
        
        if(empty($message))
                $message = '';

            $uf = '';
            if(isset($session['user_flag']))
                $uf = $session['user_flag'];
            
        $messages[$user['user_id']] = array( "messages" => $message , "user_flag" => $uf );

    }
    endif;

    echo json_encode($messages);

elseif($type == 'get-all-visitors') :

    $visitors = get_transient('LEAP_Visitor_tree' );
    
    if(!$visitors)
        $visitors=  array();

    echo json_encode($visitors);

elseif($type=='user-auth') :
    
    $user_id = $_POST['user_id'];
    $visitors = get_transient('LEAP_Visitor_tree' );

    if(isset($visitors[$user_id])) :
    
        $visitors[$user_id]['user_time'] =  time();
        echo $visitors[$user_id]['user_time'] ;
    
    endif;

    set_transient('LEAP_Visitor_tree', $visitors); 

elseif($type == 'translate_smiley') :

    $text = '';
    
    if(isset($_POST['text']))
        $text = $_POST['text'];

    echo convert_smilies(stripslashes($text));

elseif($type=="options_save" && current_user_can('edit_pages') ) :

    $options =  $_POST['options'];

    foreach($options as $value)
    {
        update_option( $value["name"], $value["value"] );
    }

endif;



die();
}


