<?php

/**
 *
 * @link              http://artillegence.com
 * @since             1.2.0
 * @package           leap_chat
 *
 * @wordpress-plugin
 * Plugin Name:       Leap Live Chat
 * Plugin URI:        http://artillegence.com
 * Description:       Mordern age Live Chat plugin with edge cutting features.
 * Version:           1.2.0
 * Author:            Artillegence System
 * Author URI:        http://artillegence.com/
 * Text Domain:       leap_chat
 * Domain Path:       /leap_chat
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}


define('leap_chat_URL',plugins_url('',__FILE__));
define('leap_chat_PATH',plugin_dir_path(__FILE__));
define('leap_chat_DEV_MODE',true); 

$my_td = 'leap';
        function leap_textdomain_init() {
            global $my_td;
            load_plugin_textdomain( $my_td,  false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

            
        }
        add_action('plugins_loaded', 'leap_textdomain_init');


        
$leap_google_webfonts = array();
$leap_websafe_fonts = array();

$leap_chat_meta_data = array();  // Global Array to hold data
                     
/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-leap_chat-activator.php
 */
function activate_leap_chat() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-leap_chat-activator.php';
	leap_chat_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-leap_chat-deactivator.php
 */
function deactivate_leap_chat() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-leap_chat-deactivator.php';
	leap_chat_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_leap_chat' );
register_deactivation_hook( __FILE__, 'deactivate_leap_chat' );


require_once('includes/class-leap_chat.php');

leap_chat::instance();



/**
 * Clean up expired sessions by removing data and their expiration entries from
 * the WordPress options table.
 *
 * This method should never be called directly and should instead be triggered as part
 * of a scheduled task or cron job.
 */
function LEAP_session_cleanup() {
	if ( defined( 'WP_SETUP_CONFIG' ) ) {
		return;
	}

	if ( ! defined( 'WP_INSTALLING' ) ) {
		
		$logs = get_option("LEAP_all_session");
		if($logs) :
			foreach ($logs as $session) {
				if(!is_array($session) && $session  == 'killed')
					delete_transient($session );
			}
		endif;

	}
	
}
add_action( 'LEAP_chat_garbage_collection', 'LEAP_session_cleanup' );

/**
 * Register the garbage collector as a twice daily event.
 */
function LEAP_chat_register_garbage_collection() {
	if ( ! wp_next_scheduled( 'LEAP_chat_garbage_collection' ) ) {
		wp_schedule_event( time(), 'daily', 'LEAP_chat_garbage_collection' );
	}
}
add_action( 'wp', 'LEAP_chat_register_garbage_collection' );


register_deactivation_hook(__FILE__, 'LEAP_CHAT_deactivation');

function LEAP_CHAT_deactivation() {
	wp_clear_scheduled_hook('LEAP_chat_garbage_collection');
}